config/urls.py
from django.conf import settings
from django.conf.urls import url, include

from django.contrib import admin
from django.contrib.auth.views import logout
from django.views.generic import TemplateView

# Import feeds
import core.views
from events.feeds import EventFeed, feedview
import events.reports
import events.views
from ligoauth.views import pre_login, post_login, shib_logout, manage_password
import search.views

# Django admin auto-discover
admin.autodiscover()

feeds = {
    'latest' : EventFeed
}


urlpatterns = [
    url(r'^$', events.views.index, name="home"),
    url(r'^navbar_only$', TemplateView.as_view(
        template_name='navbar_only.html'), name="navbar-only"),
    url(r'^SPInfo', TemplateView.as_view(template_name='gracedb/spinfo.html'),
         name="spinfo"),
    url(r'^SPPrivacy', TemplateView.as_view(
        template_name='gracedb/spprivacy.html'), name="spprivacy"),
    url(r'^DiscoveryService', TemplateView.as_view(
        template_name='discovery.html'), name="discovery"),
    url(r'^events/', include('events.urls')),
    url(r'^superevents/', include('superevents.urls')),
    url(r'^alerts/', include('alerts.urls')),
    url(r'^feeds/(?P<url>.*)/$', EventFeed()),
    url(r'^feeds/$', feedview, name="feeds"),

    url(r'^other/$', TemplateView.as_view(template_name='other.html'),
        name='other'),
    url(r'^performance/$', events.views.performance, name="performance"),
    url(r'^reports/$', events.reports.histo, name="reports"),
    url(r'^reports/cbc_report/(?P<format>(json|flex))?$',
        events.reports.cbc_report, name="cbc_report"),
    url(r'^latest/$', search.views.latest, name="latest"),
    #(r'^reports/(?P<path>.+)$', 'django.views.static.serve',
    #        {'document_root': settings.LATENCY_REPORT_DEST_DIR}),
    url(r'^search/$', search.views.search, name="mainsearch"),

    # Authentication
    url(r'^login/$', pre_login, name='login'),
    url(r'^post-login/$', post_login, name='post-login'),
    url(r'^logout/$', shib_logout, name='logout'),

    # Password management
    url('^manage-password/$', manage_password, name='manage-password'),

    # API URLs
    url(r'^api/', include('api.urls')),
    # Legacy API URLs - must be maintained!
    url(r'^apibasic/', include('api.urls', namespace='legacy_apibasic')),
    url(r'^apiweb/', include('api.urls', namespace='legacy_apiweb')),

    # Heartbeat URL
    url(r'^heartbeat/$', core.views.heartbeat, name='heartbeat'),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs'
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^admin/', admin.site.urls),

    # Sessions
    url(r'^', include('user_sessions.urls', 'user_sessions')),

]

# We don't require settings.DEBUG for django-silk since running unit tests
# by default setings settings.DEBUG to False, unless you use the
# --debug-mode flag
if ('silk' in settings.INSTALLED_APPS):
    # Add django-silk
    urlpatterns = [
        url(r'^silk/', include('silk.urls', namespace='silk'))
    ] + urlpatterns

# Add django-debug-toolbar
if settings.DEBUG and 'debug_toolbar' in settings.INSTALLED_APPS:
    import debug_toolbar
    urlpatterns = [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns

gracedb/alerts/urls.py
from django.conf.urls import url

from . import views

app_name = 'alerts'


urlpatterns = [
    # Base /options/ URL
    url(r'^$', views.index, name="index"),

    # Contacts
    url(r'^contact/create/', views.CreateContactView.as_view(),
        name='create-contact'),
    url(r'^contact/(?P<pk>\d+)/edit/$', views.EditContactView.as_view(),
        name="edit-contact"),
    url(r'^contact/(?P<pk>\d+)/delete/$', views.DeleteContactView.as_view(),
        name="delete-contact"),
    url(r'^contact/(?P<pk>\d+)/test/$', views.TestContactView.as_view(),
        name="test-contact"),
    url(r'^contact/(?P<pk>\d+)/request-code/$',
        views.RequestVerificationCodeView.as_view(),
        name="request-verification-code"),
    url(r'^contact/(?P<pk>\d+)/verify/$', views.VerifyContactView.as_view(),
        name="verify-contact"),

    # Notifications
    url(r'^notification/create/$', views.CreateNotificationView.as_view(),
        name="create-notification"),
    url(r'^notification/(?P<pk>\d+)/edit/$',
        views.EditNotificationView.as_view(), name="edit-notification"),
    url(r'^notification/(?P<pk>\d+)/delete/$',
        views.DeleteNotificationView.as_view(), name="delete-notification"),
]

gracedb/api/urls.py
from django.conf.urls import url, include

from .v1 import urls as v1_urls
from .v2 import urls as v2_urls

app_name = 'api'


urlpatterns = [
    url(r'^', include((v1_urls, 'default'))),
    url(r'^v1/', include((v1_urls, 'v1'))),
    url(r'^v2/', include((v2_urls, 'v2'))),
]

gracedb/core/urls.py
# URL utilities

from django.contrib.sites.models import Site


def build_absolute_uri(relative_uri, request=None):
    if request is not None:
        return request.build_absolute_uri(relative_uri)
    else:
        # Assume HTTPS
        domain = Site.objects.get_current().domain
        return 'https://' + domain + relative_uri

gracedb/alerts/views.py
import logging

from django.conf import settings
from django.contrib import messages
from django.core.mail import EmailMessage
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse, reverse_lazy
from django.utils import timezone
from django.utils.decorators import method_decorator
from django.views.generic.edit import DeleteView, UpdateView
from django.views.generic.detail import DetailView

from django_twilio.client import twilio_client

from core.views import MultipleFormView
from ligoauth.decorators import internal_user_required
from .forms import (
    PhoneContactForm, EmailContactForm, VerifyContactForm,
    EventNotificationForm, SupereventNotificationForm,
)
from .models import Contact, Notification
from .phone import get_twilio_from


# Set up logger
logger = logging.getLogger(__name__)


###############################################################################
# Generic views ###############################################################
###############################################################################
@internal_user_required
def index(request):
    context = {
        'notifications': request.user.notification_set.all(),
        'contacts': request.user.contact_set.all(),
    }

    return render(request, 'alerts/index.html', context=context)


###############################################################################
# Notification views ##########################################################
###############################################################################
@method_decorator(internal_user_required, name='dispatch')
class CreateNotificationView(MultipleFormView):
    """Create a notification"""
    template_name = 'alerts/create_notification.html'
    success_url = reverse_lazy('alerts:index')
    form_classes = [SupereventNotificationForm, EventNotificationForm]

    def get_context_data(self, **kwargs):
        kwargs['idx'] = 0
        if (self.request.method in ('POST', 'PUT')):
            form_keys = [f.key for f in self.form_classes]
            idx = form_keys.index(self.request.POST['key_field'])
            kwargs['idx'] = idx
        return kwargs

    def get_form_kwargs(self, *args, **kwargs):
        kw = super(CreateNotificationView, self).get_form_kwargs(
            *args, **kwargs)
        kw['user'] = self.request.user
        return kw

    def form_valid(self, form):
        if form.cleaned_data.has_key('key_field'):
            form.cleaned_data.pop('key_field')

        # Add user (from request) and category (stored on form class) to
        # the form instance, then save
        form.instance.user = self.request.user
        form.instance.category = form.category
        form.save()

        # Add message and return
        messages.info(self.request, 'Created notification: {n}.'.format(
            n=form.instance.description))
        return super(CreateNotificationView, self).form_valid(form)

    def get(self, request, *args, **kwargs):
        # Make sure user has at least one verified contact; if not, redirect
        # and display an error message
        user_has_verified_contact = request.user.contact_set.filter(
            verified=True).exists()
        if not user_has_verified_contact:
            messages.error(request, ('Error: you have no verified contacts. '
                'Create and verify a contact before creating a notification.'))
            return HttpResponseRedirect(reverse('alerts:index'))

        return super(CreateNotificationView, self).get(request, *args,
            **kwargs)

    superevent_form_valid = event_form_valid = form_valid


@method_decorator(internal_user_required, name='dispatch')
class EditNotificationView(UpdateView):
    """Edit a notification"""
    template_name = 'alerts/edit_notification.html'
    # Have to provide form_class, but it will be dynamically selected below in
    # get_form()
    form_class = SupereventNotificationForm
    success_url = reverse_lazy('alerts:index')

    def get_form_class(self):
        if self.object.category == Notification.NOTIFICATION_CATEGORY_EVENT:
            return EventNotificationForm
        else:
            return SupereventNotificationForm

    def get_form_kwargs(self, *args, **kwargs):
        kw = super(EditNotificationView, self).get_form_kwargs(
            *args, **kwargs)
        kw['user'] = self.request.user

        # Cases that have a label query actually have labels in the database.
        # But we don't want to include those in the form because
        # a) it's confusing and b) it breaks the form
        if self.object.label_query and self.object.labels.exists():
            kw['initial']['labels'] = None
        return kw

    def get_queryset(self):
        return self.request.user.notification_set.all()


@method_decorator(internal_user_required, name='dispatch')
class DeleteNotificationView(DeleteView):
    """Delete a notification"""
    success_url = reverse_lazy('alerts:index')

    def get(self, request, *args, **kwargs):
        # Override this so that we don't require a confirmation page
        # for deletion
        return self.delete(request, *args, **kwargs)

    def delete(self, request, *args, **kwargs):
        response = super(DeleteNotificationView, self).delete(request, *args,
            **kwargs)
        messages.info(request, 'Notification "{n}" has been deleted.'.format(
            n=self.object.description))
        return response

    def get_queryset(self):
        # Queryset should only contain the user's notifications
        return self.request.user.notification_set.all()


###############################################################################
# Contact views ###############################################################
###############################################################################
@method_decorator(internal_user_required, name='dispatch')
class CreateContactView(MultipleFormView):
    """Create a contact"""
    template_name = 'alerts/create_contact.html'
    success_url = reverse_lazy('alerts:index')
    form_classes = [PhoneContactForm, EmailContactForm]

    def get_context_data(self, **kwargs):
        kwargs['idx'] = 0
        if (self.request.method in ('POST', 'PUT')):
            form_keys = [f.key for f in self.form_classes]
            idx = form_keys.index(self.request.POST['key_field'])
            kwargs['idx'] = idx
        return kwargs

    def form_valid(self, form):

        # Remove key_field, add user, and save form
        if form.cleaned_data.has_key('key_field'):
            form.cleaned_data.pop('key_field')
        form.instance.user = self.request.user
        form.save()

        # Generate message and return
        messages.info(self.request, 'Created contact "{cname}".'.format(
            cname=form.instance.description))
        return super(CreateContactView, self).form_valid(form)

    email_form_valid = phone_form_valid = form_valid


@method_decorator(internal_user_required, name='dispatch')
class EditContactView(UpdateView):
    """
    Edit a contact. Users shouldn't be able to edit the actual email address
    or phone number since that would allow them to circumvent the verification
    process.
    """
    template_name = 'alerts/edit_contact.html'
    # Have to provide form_class, but it will be dynamically selected below in
    # get_form()
    form_class = PhoneContactForm
    success_url = reverse_lazy('alerts:index')

    def get_form_class(self):
        if self.object.phone is not None:
            return PhoneContactForm
        else:
            return EmailContactForm
        return self.form_class

    def get_form(self, form_class=None):
        form = super(EditContactView, self).get_form(form_class)
        if isinstance(form, PhoneContactForm):
            form.fields['phone'].disabled = True
        elif isinstance(form, EmailContactForm):
            form.fields['email'].disabled = True
        return form

    def get_queryset(self):
        return self.request.user.contact_set.all()


@method_decorator(internal_user_required, name='dispatch')
class DeleteContactView(DeleteView):
    """Delete a contact"""
    success_url = reverse_lazy('alerts:index')

    def get(self, request, *args, **kwargs):
        # Override this so that we don't require a confirmation page
        # for deletion
        return self.delete(request, *args, **kwargs)

    def delete(self, request, *args, **kwargs):
        # Get contact
        self.object = self.get_object()

        # Contacts can only be deleted if they aren't part of a notification -
        # this will prevent cases where a user creates a notification, deletes
        # the related contact(s), and then wonders why they aren't getting
        # any notifications.
        if self.object.notification_set.exists():
            messages.error(request, ('Contact "{cname}" cannot be deleted '
                'because it is part of a notification. Remove it from the '
                'notification or delete the notification first.').format(
                cname=self.object.description))
            return HttpResponseRedirect(reverse('alerts:index'))

        # Otherwise, delete the contact and show a corresponding message.
        self.object.delete()
        messages.info(request, 'Contact "{cname}" has been deleted.'.format(
            cname=self.object.description))
        return HttpResponseRedirect(self.get_success_url())

    def get_queryset(self):
        # Queryset should only contain the user's contacts
        return self.request.user.contact_set.all()


@method_decorator(internal_user_required, name='dispatch')
class TestContactView(DetailView):
    """Test a contact (must be verified already)"""
    # Send alerts to all contact methods
    success_url = reverse_lazy('alerts:index')

    def get_queryset(self):
        return self.request.user.contact_set.all()

gracedb/api/v2/events/views.py
from ...v1.events.views import *

gracedb/api/v2/main/views.py
from ...v1.main.views import *

gracedb/api/v2/superevents/views.py
from ...v1.superevents.views import *

gracedb/core/views.py
from django.http import HttpResponse
from django.views.generic.edit import FormView

import logging
logger = logging.getLogger(__name__)

def heartbeat(request):
    # Do something (?) and return 200 response
    return HttpResponse()


class MultipleFormView(FormView):
    """Requires forms to inherit from core.forms.MultipleForm"""
    form_classes = []

    @property
    def form_classes(self):
        if not hasattr(self, '_form_classes'):
            self._form_classes = {f.key: f for f in self.form_class_list}
        return self._form_classes

    def get_forms(self, form_classes=None):
        if (form_classes is None):
            form_classes = self.form_classes
        return [form(**self.get_form_kwargs(form.key)) for form in
            form_classes]

    def get_form_kwargs(self, form_key):
        kwargs = {
            'initial': self.get_initial(),
            'prefix': self.get_prefix(),
        }
        if (self.request.method in ('POST', 'PUT')):
            key_field = self.request.POST.get('key_field', None)
            if (key_field is not None and key_field == form_key):
                kwargs.update({'data': self.request.POST,
                    'files': self.request.FILES})
        return kwargs

    def get(self, request, *args, **kwargs):
        forms = self.get_forms()
        return self.render_to_response(self.get_context_data(forms=forms))

    def post(self, request, *args, **kwargs):
        form_key = request.POST.get('key_field')
        forms = self.get_forms()
        return self._process_individual_form(form_key, forms)

    def forms_valid(self, form):
        form_valid_method = '{key}_form_valid'.format(key=form.key)
        if hasattr(self, form_valid_method):
            return getattr(self, form_valid_method)(form)
        else:
            return HttpResponseRedirect(self.success_url)

    def forms_invalid(self, forms):
        return self.render_to_response(self.get_context_data(forms=forms))

    def _get_form_by_key(self, key, forms):
        form_keys = [f.key for f in forms]
        return forms[form_keys.index(key)]

    def _process_individual_form(self, form_key, forms):
        form = self._get_form_by_key(form_key, forms)
        if form.is_valid():
            return self.forms_valid(form)
        else:
            return self.forms_invalid(forms)

gracedb/templates/alerts/create_contact.html
{% extends "base.html" %}
{% load static %}

{% block headcontents %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static "jquery-ui/themes/base/jquery-ui.min.css" %}" />
{% endblock %}

{% block jscript %}
<script src="{% static "jquery/dist/jquery.min.js" %}"></script>
<script src="{% static "jquery-ui/jquery-ui.min.js" %}"></script>
<script type="text/javascript">
$(document).ready(function() {
    $("#tabs").toggle();
    $("#tabs").tabs({active: {{ idx }}});
});
</script>
{% endblock %}

{% block title %}Options | Create Contact{% endblock %}
{% block heading %}Create Contact{% endblock %}
{% block pageid %}alerts{% endblock %}



{% block content %}

<br />
<div style="padding: 10px;">
<h3>Instructions</h3>
<ul>
    <li>Choose an alert type (email or phone).</li>
    <li>A description is required.</li>
    <li>For phone alerts, choose call, text, or both.</li>
    <li><b>IMPORTANT: after your contact is created, it must be verified before you can receive alerts.</b> You can verify contacts on the previous page where a list of your available contacts is shown.</li>
</ul>
</div>

<div id="tabs" style="min-width: 300px; max-width: 400px; display: none;">
  <ul>
    {% for form in forms %}
    <li><a href="#tab-{{ forloop.counter }}">{{ form.key|title }} alert</a></li>
    {% endfor %}
  </ul>
  {% for form in forms %}
  <div id="tab-{{ forloop.counter }}">
    <form method="POST" class="contactform">
      <table>
        {{ form.as_table }}
      </table>
      <input type="submit" value="Submit" />
    </form>
  </div>
  {% endfor %}
</div>


{% endblock %}

gracedb/templates/alerts/create_notification.html
{% extends "base.html" %}
{% load static %}

{% block headcontents %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static "jquery-ui/themes/base/jquery-ui.min.css" %}" />
{% endblock %}

{% block jscript %}
<script src="{% static "jquery/dist/jquery.min.js" %}"></script>
<script src="{% static "jquery-ui/jquery-ui.min.js" %}"></script>
<script type="text/javascript">
$(document).ready(function() {
    $("#tabs").toggle();
    $("#tabs").tabs({active: {{ idx }}});
});
</script>
{% endblock %}

{% block title %}Options | Create Notification{% endblock %}
{% block heading %}Create Notification{% endblock %}
{% block pageid %}alerts{% endblock %}

{% block content %}

<br />
<div style="padding: 10px;">
<h3>Instructions</h3>
<ul>
    <li>Select an alert type (superevent or event).</li>
    <li>A description is required.</li>
    <li>One or more values can be selected for certain fields (contacts, labels, groups, pipelines, and searches). Use CTRL + click to select multiples in a field.</li>
    <li>See the <a href="{% url "home" %}documentation/notifications.html">documentation</a> for detailed information about creating notifications and how the notification fields are translated into logic for deciding when alerts should be sent.</li>
</ul>
</div>

<div id="tabs" style="min-width: 300px; max-width: 700px; display: none;">
  <ul>
    {% for form in forms %}
    <li><a href="#tab-{{ forloop.counter }}">{{ form.key|title }} alert</a></li>
    {% endfor %}
  </ul>
  {% for form in forms %}
  <div id="tab-{{ forloop.counter }}">
    <form method="POST" class="contactform">
      <table>
        {{ form.as_table }}
      </table>
      <input type="submit" value="Submit" />
    </form>
  </div>
  {% endfor %}
</div>

{% endblock %}

gracedb/templates/alerts/edit_contact.html
{% extends "base.html" %}

{% block title %}Options | Edit Contact{% endblock %}
{% block heading %}Edit contact &quot;{{ object.description }}&quot;{% endblock %}

{% block content %}
<br />

<div style="min-width: 300px; max-width: 400px;">
<form method="POST">
    <table>
        {{ form.as_table }}
    </table>
    <input type="submit" value="Submit" />
</form>
</div>

{% endblock %}

gracedb/templates/alerts/edit_notification.html
{% extends "base.html" %}

{% block title %}Options | Edit Notification{% endblock %}
{% block heading %}Edit notification &quot;{{ object.description }}&quot;{% endblock %}

{% block content %}
<br />

<div style="min-width: 300px; max-width: 700px;">
<form method="POST">
    <table>
        {{ form.as_table }}
    </table>
    <input type="submit" value="Submit" />
</form>
</div>

{% endblock %}

gracedb/templates/alerts/index.html
{% extends "base.html" %}

{% block title %}Alerts{% endblock %}
{% block heading %}<!-- leave heading blank -->{% endblock %}
{% block pageid %}alerts{% endblock %}

{% load static %}
{% block headcontents %}
    <link rel="stylesheet" href="{% static "css/bootstrap_buttons.css" %}"></script>
    {{ block.super }}
{% endblock %}

{% block content %}

{% if messages %}
<div class="flash">
    {% for m in messages %}
        <p>{{ m }}</p>
    {% endfor %}
</div>
{% endif %}

<h1>Phone and email alerts</h1>
<div style="max-width: 1000px;">
<p>
This is the central page for managing phone and email alerts.
From here, you can create new contacts and notifications, edit or delete existing ones, and test and verify contacts.
</p>
<p>The general procedure is:</p>
<ul>
    <li>Create a contact</li>
    <li>Verify that contact</li>
    <li>Create a notification</li>
</ul>

<p>More detailed documentation is provided <a href="{% url "home" %}documentation/notifications.html">here</a>.</p>

<p><b>Note:</b> email alerts in ER14 and O3 will come from the <b><code style="font-size: 1.8rem;">gravitationalwave.services</code></b> domain.</p>
</div>

<h2>Contacts</h2>
{% if contacts %}
<table style="padding-bottom: 10px">
{% for contact in contacts %}
    <tr>
        <td>
        {% if contact.verified %}
            <a class="btn btn-primary" href="{% url "alerts:test-contact" contact.pk %}">Test</a>
        {% else %}
            <button class="btn btn-primary" disabled>Test</button>
        {% endif %}
        </td>
        <td><a class="btn btn-secondary" href="{% url "alerts:edit-contact" contact.pk %}">Edit</a></td>
        <td><a class="btn btn-danger" href="{% url "alerts:delete-contact" contact.pk %}">Delete</a></td>
        <td>
            <b>{{ contact.description }}</b> | {{ contact.display }}
            <b>
                {% if contact.verified %}
                    <div style="color: green; display: inline-block;">Verified</div>
                {% else %}
                    <div style="color: red; display: inline-block;">Not verified</div>
                    <a class="btn btn-warning" href="{% url "alerts:verify-contact" contact.pk %}">Verify</a>
                {% endif %}
            </b>
        </td>
    </tr>
{% endfor %}
</table>
{% endif %}

<a class="btn btn-success" href="{% url "alerts:create-contact" %}">Create new contact</a>
<br /><br /><br />

<h2>Notifications</h2>
{% if notifications %}
<table style="padding-bottom: 10px;">
{% for notification in notifications %}
    <tr>
        <td><a class="btn btn-secondary" href="{% url "alerts:edit-notification" notification.pk %}">Edit</a></td>
        <td><a class="btn btn-danger" href="{% url "alerts:delete-notification" notification.pk %}">Delete</a></td>
        <td><b>{{ notification.description }}</b> | {{ notification.display }}</td>
    </tr>
{% endfor %}
</table>
{% endif %}

<a class="btn btn-success" href="{% url "alerts:create-notification" %}">Create new notification</a>
{% endblock %}

gracedb/templates/alerts/verify_contact.html
{% extends "base.html" %}
{% load static %}

{% block headcontents %}
    <link rel="stylesheet" href="{% static "css/bootstrap_buttons.css" %}"></script>
    {{ block.super }}
{% endblock %}

{% block title %}Verify contact{% endblock %}
{% block heading %}
Verify contact &quot;{{ contact.description }}&quot;
{% endblock %}


{% block content %}

<br />
{% if messages %}
<div class="flash">
    {% for m in messages %}
        <p>{{ m }}</p>
    {% endfor %}
</div>
{% endif %}

{% if object.verified %}
This contact is already verified.
{% else %}
    <h3>A verification code will be sent via:</h3>
    <ul>
        <li>Email for email contacts</li>
        <li>Text message for phone contacts who have specified &quot;text&quot; or &quot;call and text&quot;</li>
        <li>Voice call for phone contacts who have specified &quot;call&quot;</li>
    </ul>
    <a class="btn btn-primary" href="{% url "alerts:request-verification-code" object.pk %}">
    {% if contact.verification_code %}
        Request a new verification code
    {% else %}
        Request a verification code
    {% endif %}
    </a>
    {% if contact.verification_code %}
    <br />
    <br />
        {% if code_expired %}
            Your verification code has expired.  Use the button above to request a new one.
        {% else %}
            Your current verification code expires in <b>{{ contact.verification_expiration|timeuntil }}</b>.
            <form method="POST">
                <table>{{ form.as_table }}</table>
                <input type="submit" value="Submit" />
            </form>
        {% endif %}
    {% endif %}
{% endif %}

{% endblock %}